CSFML - C binding of the Simple and Fast Multimedia Library

CSFML 3.0.0
Loading...
Searching...
No Matches
Functions
Shader.h File Reference
`#include <CSFML/Graphics/Export.h>`
`#include <CSFML/Graphics/Color.h>`
`#include <CSFML/Graphics/Glsl.h>`
`#include <CSFML/Graphics/Transform.h>`
`#include <CSFML/Graphics/Types.h>`
`#include <CSFML/System/InputStream.h>`
`#include <CSFML/System/Vector2.h>`
`#include <CSFML/System/Vector3.h>`
`#include <stddef.h>`

Go to the source code of this file.

## Functions
sfShader * | sfShader_createFromFile (const char *vertexShaderFilename, const char *geometryShaderFilename, const char *fragmentShaderFilename)
| Load the vertex, geometry and fragment shaders from files.
sfShader * | sfShader_createFromMemory (const char *vertexShader, const char *geometryShader, const char *fragmentShader)
| Load the vertex, geometry and fragment shaders from source code in memory.
sfShader * | sfShader_createFromStream (sfInputStream *vertexShaderStream, sfInputStream *geometryShaderStream, sfInputStream *fragmentShaderStream)
| Load the vertex, geometry and fragment shaders from custom streams.
void | sfShader_destroy (const sfShader *shader)
| Destroy an existing shader.
void | sfShader_setFloatUniform (sfShader *shader, const char *name, float x)
| Specify value for `float` uniform.
void | sfShader_setVec2Uniform (sfShader *shader, const char *name, sfGlslVec2 vector)
| Specify value for `vec2` uniform.
void | sfShader_setVec3Uniform (sfShader *shader, const char *name, sfGlslVec3 vector)
| Specify value for `vec3` uniform.
void | sfShader_setVec4Uniform (sfShader *shader, const char *name, sfGlslVec4 vector)
| Specify value for `vec4` uniform.
void | sfShader_setColorUniform (sfShader *shader, const char *name, sfColor color)
| Specify value for `vec4` uniform.
void | sfShader_setIntUniform (sfShader *shader, const char *name, int x)
| Specify value for `int` uniform.
void | sfShader_setIvec2Uniform (sfShader *shader, const char *name, sfGlslIvec2 vector)
| Specify value for `ivec2` uniform.
void | sfShader_setIvec3Uniform (sfShader *shader, const char *name, sfGlslIvec3 vector)
| Specify value for `ivec3` uniform.
void | sfShader_setIvec4Uniform (sfShader *shader, const char *name, sfGlslIvec4 vector)
| Specify value for `ivec4` uniform.
void | sfShader_setIntColorUniform (sfShader *shader, const char *name, sfColor color)
| Specify value for `ivec4` uniform.
void | sfShader_setBoolUniform (sfShader *shader, const char *name, bool x)
| Specify value for `bool` uniform.
void | sfShader_setBvec2Uniform (sfShader *shader, const char *name, sfGlslBvec2 vector)
| Specify value for `bvec2` uniform.
void | sfShader_setBvec3Uniform (sfShader *shader, const char *name, sfGlslBvec3 vector)
| Specify value for `Bvec3` uniform.
void | sfShader_setBvec4Uniform (sfShader *shader, const char *name, sfGlslBvec4 vector)
| Specify value for `bvec4` uniform.
void | sfShader_setMat3Uniform (sfShader *shader, const char *name, const sfGlslMat3 *matrix)
| Specify value for `mat3` matrix.
void | sfShader_setMat4Uniform (sfShader *shader, const char *name, const sfGlslMat4 *matrix)
| Specify value for `mat4` matrix.
void | sfShader_setTextureUniform (sfShader *shader, const char *name, const sfTexture *texture)
| Specify a texture as `sampler2D` uniform.
void | sfShader_setCurrentTextureUniform (sfShader *shader, const char *name)
| Specify current texture as `sampler2D` uniform.
void | sfShader_setFloatUniformArray (sfShader *shader, const char *name, const float *scalarArray, size_t length)
| Specify values for `float`[] array uniform.
void | sfShader_setVec2UniformArray (sfShader *shader, const char *name, const sfGlslVec2 *vectorArray, size_t length)
| Specify values for `vec2`[] array uniform.
void | sfShader_setVec3UniformArray (sfShader *shader, const char *name, const sfGlslVec3 *vectorArray, size_t length)
| Specify values for `vec3`[] array uniform.
void | sfShader_setVec4UniformArray (sfShader *shader, const char *name, const sfGlslVec4 *vectorArray, size_t length)
| Specify values for `vec4`[] array uniform.
void | sfShader_setMat3UniformArray (sfShader *shader, const char *name, const sfGlslMat3 *matrixArray, size_t length)
| Specify values for `mat3`[] array uniform.
void | sfShader_setMat4UniformArray (sfShader *shader, const char *name, const sfGlslMat4 *matrixArray, size_t length)
| Specify values for `mat4`[] array uniform.
unsigned int | sfShader_getNativeHandle (const sfShader *shader)
| Get the underlying OpenGL handle of the shader.
void | sfShader_bind (const sfShader *shader)
| Bind a shader for rendering (activate it).
bool | sfShader_isAvailable (void)
| Tell whether or not the system supports shaders.
bool | sfShader_isGeometryAvailable (void)
| Tell whether or not the system supports geometry shaders.

## Function Documentation

## ◆ sfShader_bind()

void sfShader_bind | ( | const sfShader * | shader | ) |

Bind a shader for rendering (activate it).

This function is not part of the graphics API, it mustn't be used when drawing SFML entities. It must be used only if you mix sfShader with OpenGL code.

sfShader *s1, *s2;
...
sfShader_bind(s1);
// draw OpenGL stuff that use s1...
sfShader_bind(s2);
// draw OpenGL stuff that use s2...
sfShader_bind(0);
// draw OpenGL stuff that use no shader...
sfShader
struct sfShader sfShader
Definition Graphics/Types.h:32
sfShader_bind
void sfShader_bind(const sfShader *shader)
Bind a shader for rendering (activate it).

Parameters

  shader | Shader to bind, can be null to use no shader

## ◆ sfShader_createFromFile()

sfShader * sfShader_createFromFile | ( | const char * | vertexShaderFilename,
|  | const char * | geometryShaderFilename,
|  | const char * | fragmentShaderFilename )

Load the vertex, geometry and fragment shaders from files.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The sources must be text files containing valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderFilename | Path of the vertex shader file to load, or NULL to skip this shader
  geometryShaderFilename | Path of the geometry shader file to load, or NULL to skip this shader
  fragmentShaderFilename | Path of the fragment shader file to load, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_createFromMemory()

sfShader * sfShader_createFromMemory | ( | const char * | vertexShader,
|  | const char * | geometryShader,
|  | const char * | fragmentShader )

Load the vertex, geometry and fragment shaders from source code in memory.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The sources must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShader | String containing the source code of the vertex shader, or NULL to skip this shader
  geometryShader | String containing the source code of the geometry shader, or NULL to skip this shader
  fragmentShader | String containing the source code of the fragment shader, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_createFromStream()

sfShader * sfShader_createFromStream | ( | sfInputStream * | vertexShaderStream,
|  | sfInputStream * | geometryShaderStream,
|  | sfInputStream * | fragmentShaderStream )

Load the vertex, geometry and fragment shaders from custom streams.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The source codes must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderStream | Source stream to read the vertex shader from, or NULL to skip this shader
  geometryShaderStream | Source stream to read the geometry shader from, or NULL to skip this shader
  fragmentShaderStream | Source stream to read the fragment shader from, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_destroy()

void sfShader_destroy | ( | const sfShader * | shader | ) |

Destroy an existing shader.

Parameters

  shader | Shader to delete

## ◆ sfShader_getNativeHandle()

unsigned int sfShader_getNativeHandle | ( | const sfShader * | shader | ) |

Get the underlying OpenGL handle of the shader.

You shouldn't need to use this function, unless you have very specific stuff to implement that SFML doesn't support, or implement a temporary workaround until a bug is fixed.

Parameters

  shader | Shader object

Returns
  OpenGL handle of the shader or 0 if not yet loaded

## ◆ sfShader_isAvailable()

bool sfShader_isAvailable | ( | void |  | ) |

Tell whether or not the system supports shaders.

This function should always be called before using the shader features. If it returns false, then any attempt to use sfShader will fail.

Returns
  true if the system can use shaders, false otherwise

## ◆ sfShader_isGeometryAvailable()

bool sfShader_isGeometryAvailable | ( | void |  | ) |

Tell whether or not the system supports geometry shaders.

This function should always be called before using the geometry shader features. If it returns false, then any attempt to use sfShader geometry shader features will fail.

This function can only return true if isAvailable() would also return true, since shaders in general have to be supported in order for geometry shaders to be supported as well.

Note: The first call to this function, whether by your code or SFML will result in a context switch.

Returns
  True if geometry shaders are supported, false otherwise

## ◆ sfShader_setBoolUniform()

void sfShader_setBoolUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | bool | x )

Specify value for `bool` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the bool scalar

## ◆ sfShader_setBvec2Uniform()

void sfShader_setBvec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec2 | vector )

Specify value for `bvec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the bvec2 vector

## ◆ sfShader_setBvec3Uniform()

void sfShader_setBvec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec3 | vector )

Specify value for `Bvec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the Bvec3 vector

## ◆ sfShader_setBvec4Uniform()

void sfShader_setBvec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec4 | vector )

Specify value for `bvec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslIvec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the bvec4 vector

## ◆ sfShader_setColorUniform()

void sfShader_setColorUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color )

Specify value for `vec4` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  color | Value of the vec4 vector

## ◆ sfShader_setCurrentTextureUniform()

void sfShader_setCurrentTextureUniform | ( | sfShader * | shader,
|  | const char * | name )

Specify current texture as `sampler2D` uniform.

This overload maps a shader texture variable to the texture of the object being drawn, which cannot be known in advance. The corresponding parameter in the shader must be a 2D texture (`sampler2D` GLSL type).

Example:

uniform sampler2D current; // this is the variable in the shader
sfShader_setCurrentTextureUniform(shader, "current");
sfShader_setCurrentTextureUniform
void sfShader_setCurrentTextureUniform(sfShader *shader, const char *name)
Specify current texture as sampler2D uniform.

Parameters

  shader | Shader object
  name | Name of the texture in the shader

## ◆ sfShader_setFloatUniform()

void sfShader_setFloatUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x )

Specify value for `float` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the float scalar

## ◆ sfShader_setFloatUniformArray()

void sfShader_setFloatUniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const float * | scalarArray,
|  | size_t | length )

Specify values for `float`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  scalarArray | pointer to array of `float` values
  length | Number of elements in the array

## ◆ sfShader_setIntColorUniform()

void sfShader_setIntColorUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color )

Specify value for `ivec4` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  color | Value of the ivec4 vector

## ◆ sfShader_setIntUniform()

void sfShader_setIntUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | int | x )

Specify value for `int` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the integer scalar

## ◆ sfShader_setIvec2Uniform()

void sfShader_setIvec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec2 | vector )

Specify value for `ivec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec2 vector

## ◆ sfShader_setIvec3Uniform()

void sfShader_setIvec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec3 | vector )

Specify value for `ivec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec3 vector

## ◆ sfShader_setIvec4Uniform()

void sfShader_setIvec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec4 | vector )

Specify value for `ivec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslIvec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec4 vector

## ◆ sfShader_setMat3Uniform()

void sfShader_setMat3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat3 * | matrix )

Specify value for `mat3` matrix.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrix | Value of the mat3 matrix

## ◆ sfShader_setMat3UniformArray()

void sfShader_setMat3UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat3 * | matrixArray,
|  | size_t | length )

Specify values for `mat3`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrixArray | pointer to array of `mat3` values
  length | Number of elements in the array

## ◆ sfShader_setMat4Uniform()

void sfShader_setMat4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat4 * | matrix )

Specify value for `mat4` matrix.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrix | Value of the mat4 matrix

## ◆ sfShader_setMat4UniformArray()

void sfShader_setMat4UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat4 * | matrixArray,
|  | size_t | length )

Specify values for `mat4`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrixArray | pointer to array of `mat4` values
  length | Number of elements in the array

## ◆ sfShader_setTextureUniform()

void sfShader_setTextureUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfTexture * | texture )

Specify a texture as `sampler2D` uniform.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2D texture (`sampler2D` GLSL type).

Example:

uniform sampler2D the_texture; // this is the variable in the shader
sfTexture texture;
...
sfShader_setTextureUniform(shader, "the_texture", &texture);
sfTexture
struct sfTexture sfTexture
Definition Graphics/Types.h:39

It is important to note that texture must remain alive as long as the shader uses it, no copy is made internally.

To use the texture of the object being drawn, which cannot be known in advance, you can pass the special value sf::Shader::CurrentTexture:

shader.setUniform("the_texture", sf::Shader::CurrentTexture).

Parameters

  shader | Shader object
  name | Name of the texture in the shader
  texture | Texture to assign

## ◆ sfShader_setVec2Uniform()

void sfShader_setVec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec2 | vector )

Specify value for `vec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec2 vector

## ◆ sfShader_setVec2UniformArray()

void sfShader_setVec2UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec2 * | vectorArray,
|  | size_t | length )

Specify values for `vec2`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec2` values
  length | Number of elements in the array

## ◆ sfShader_setVec3Uniform()

void sfShader_setVec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec3 | vector )

Specify value for `vec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec3 vector

## ◆ sfShader_setVec3UniformArray()

void sfShader_setVec3UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec3 * | vectorArray,
|  | size_t | length )

Specify values for `vec3`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec3` values
  length | Number of elements in the array

## ◆ sfShader_setVec4Uniform()

void sfShader_setVec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec4 | vector )

Specify value for `vec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslVec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec4 vector

## ◆ sfShader_setVec4UniformArray()

void sfShader_setVec4UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec4 * | vectorArray,
|  | size_t | length )

Specify values for `vec4`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec4` values
  length | Number of elements in the array